import Day5Lib
import Test.HUnit
import Text.Parsec

tParseCrate = TestCase $ assertEqual "parse crate" (Right (Crate 'A')) (parse crate "" "[A]")

tParseCrateOrNothing1 =
  TestCase $
    assertEqual
      "parse crate or nothing: crate"
      (Right (Just (Crate 'A')))
      (parse crateOrNothing "" "[A]")

tParseCrateOrNothing2 =
  TestCase $
    assertEqual
      "parse crate or nothing: nothing"
      (Right Nothing)
      (parse crateOrNothing "" "   ")

tCrateRow =
  TestCase $
    assertEqual
      "parse row"
      (Right [Nothing, Just (Crate 'D'), Nothing])
      (parse crateRow "" "    [D]    \n")

tNumberRow =
  TestCase $
    assertEqual
      "number row"
      (Right ())
      (parse crateNumbers " " " 1   2   3 \n")

tCommand1 =
  TestCase $
    assertEqual
      "command"
      (Right Command {cnt = 1, from = 0, to = 1})
      (parse command " " "move 1 from 1 to 2\n")

tCommand2 =
  TestCase $
    assertEqual
      "command"
      (Right Command {cnt = 1, from = 0, to = 1})
      (parse command " " "move 1 from 1 to 2")

tStackBuild1 =
  TestCase $
    assertEqual
      "stack build"
      [[], [Crate 'D'], []]
      (transposeRows [[Nothing, Just (Crate 'D'), Nothing]])

tStackBuild2 =
  TestCase $
    assertEqual
      "stack build"
      [[Crate 'A'], [Crate 'D', Crate 'B'], [Crate 'C']]
      ( transposeRows
          [ [Nothing, Just (Crate 'D'), Nothing],
            [Just (Crate 'A'), Just (Crate 'B'), Just (Crate 'C')]
          ]
      )

tests =
  TestList $
    [ tParseCrate,
      tParseCrateOrNothing1,
      tParseCrateOrNothing2,
      tCrateRow,
      tNumberRow,
      tCommand1,
      tCommand2,
      tStackBuild1,
      tStackBuild2
    ]

main :: IO ()
main = do
  runTestTT tests
  return ()
