module Day6Lib
  ( --
    processInput1,
    processInput2,
  )
where

import Data.List (sort)
-- import Debug.Trace

createTiles :: Int -> [a] -> [[a]]
createTiles size list
  | length list >= size = take size list : createTiles size (tail list)
  | otherwise = []

allUnique :: Ord a => [a] -> Bool
allUnique = allUnique' . sort

allUnique' [] = True
allUnique' [e] = True
allUnique' (e1 : e2 : l) = e1 /= e2 && allUnique' (e2 : l)

-- ####################

processInput1 :: String -> Int
processInput1 = (+ 4) . length . (takeWhile not) . (map allUnique) . createTiles 4

processInput2 :: String -> Int
processInput2 = (+ 14) . length . (takeWhile not) . (map allUnique) . createTiles 14
