import Day6Lib (processInput1, processInput2)
import System.IO
import Test.HUnit

testCases1 =
  [ ("data/input0601.txt", 7),
    ("data/input0602.txt", 5),
    ("data/input0603.txt", 6),
    ("data/input0604.txt", 10),
    ("data/input0605.txt", 11),
    ("data/input061.txt", 1920)
  ]

testCase1 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput1 contents
    )

testCases2 =
  [ ("data/input0601.txt", 19),
    ("data/input0602.txt", 23),
    ("data/input0603.txt", 23),
    ("data/input0604.txt", 29),
    ("data/input0605.txt", 26),
    ("data/input061.txt", 2334)
  ]

testCase2 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual ("input test: " ++ file) result $ processInput2 contents
    )

tests =
  TestList $
    [TestCase (testCase1 c) | c <- testCases1]
      ++ [TestCase (testCase2 c) | c <- testCases2]

main :: IO ()
main = do
  runTestTT tests
  return ()
